use strictures 1;
use Test::More;
use Module::Runtime qw(use_module);
use DX::Utils qw(:builders);

my $ab = use_module('DX::ActionBuilder::UnsetValue')->new(
  target_path => [ 0, 'X' ]
);

my $scope = use_module('DX::Scope')->new(
  predicates => {
    '=' => use_module('DX::Predicate::Equals')->new,
    member_at => use_module('DX::Predicate::MemberAt')->new,
    is_dict => use_module('DX::Predicate::IsDict')->new,
  },
  globals => dict(),
  locals => [
    dict(
      X => use_module('DX::Value::Unset')->new(
             identity_path => [ 0, 'X' ],
             action_builder => $ab,
           ),
    ),
  ],
);

my $hyp = use_module('DX::Hypothesis')->new(
  scope => $scope,
  resolved_propositions => use_module('DX::ResolvedPropositionSet')->new_empty,
  outstanding_propositions => [
    proposition(is_dict => 'X'),
    proposition(member_at => 'X', string('a'), string('b')),
  ],
  actions => [],
);

my $ss = use_module('DX::SearchState')->new(
  current_hypothesis => $hyp,
  alternatives => [],
);

::Dwarn($ss->with_one_step->with_one_step);
